clear all
close all
setpath
getparams
setup
do

taux=[1 2 4 5 8 10 14 16];%equations with limited information

load C:\Macro\ACEL04\comparetojonas\yunits\var20pi_yunits.mat
warning off MATLAB:eigs:TooManyRequestedEigsForComplexNonsym

xx  =   [0.2388
0.3654
3.3624
0.9164
0.6743
0.3753
0.2128
0.2571
0.0642
0.3122
1.0581
2.2201
0.7178
0.6510
1.01
2.0136
1.1942
0.2599
0.0346];

chk=0;
undo
[mu_zstar,rhotilde,infl,R,eta_pr,sig_eta,s,R_nu,wtilde,kbar,h,c,q,m,ytilde,phi,i,params_ss,steady,lambda_zstar,mutilde,stst] = ...
    getsteady(alph,b,bet,delta,epsilon,eta,lambda_f,lambda_w,mu_ups,mu_z,nu,psi_L,sigma_L,x,xi_w,V,chk);

[alpha_0,alpha_1,alpha_2,beta_0,beta_1,params_mat,tau,P] = ...
    getlinear(params_ss,kappa,sigma_a,gam,squig,vartheta,rho_M,theta_M,rho_muz,theta_muz,c_z,cp_z,rho_xz,rho_muups, ...
    theta_muups,c_ups,cp_ups,rho_xups,steady);
alphas   = [ alpha_0, alpha_1, alpha_2];
[A] = findandcheckA(alphas,alpha_2,alpha_1,alpha_0);
[B,rho] = findB(P,A,beta_0,beta_1,alpha_0,alpha_1,alpha_2,rho_M,theta_M,taux,chk);
nn              =   length(rho);
T               =   21;
e1              =   zeros(nn,T);
e1(6,1)         =   sig_muups;
e1(7,1)         =   sig_muups;
e1(8,1)         =   c_ups*sig_muups;
[zz1,s1]        =   simulate(A,B,rho,e1);
e2              =   zeros(nn,T);
e2(3,1)         =   sig_muz;
e2(4,1)         =   sig_muz;
e2(5,1)         =   c_z*sig_muz;
[zz2,s2]        =   simulate(A,B,rho,e2);
modirf1     =   unscaleforplots(zz1,s1,alph,R,infl)';
modirf2     =   unscaleforplots(zz2,s2,alph,R,infl)';

xx    =   [0.2388
0.3654
0
0.9164
0.6743
0
0.2128
0.2571
0.0642
0.3122
1.0581
2.2201
0.7178
0.6510
1.01
2.0136
0
0
0.0346];
undo
[alpha_0,alpha_1,alpha_2,beta_0,beta_1,params_mat,tau,P] = ...
    getlinear(params_ss,kappa,sigma_a,gam,squig,vartheta,rho_M,theta_M,rho_muz,theta_muz,c_z,cp_z,rho_xz,rho_muups, ...
    theta_muups,c_ups,cp_ups,rho_xups,steady);
alphas   = [ alpha_0, alpha_1, alpha_2];
[A] = findandcheckA(alphas,alpha_2,alpha_1,alpha_0);
[B_c,rho_c] = findB(P,A,beta_0,beta_1,alpha_0,alpha_1,alpha_2,rho_M,theta_M,taux,chk);
nn              =   length(rho);
T               =   21;
e1              =   zeros(nn,T);
e1(6,1)         =   sig_muups;
e1(7,1)         =   sig_muups;
e1(8,1)         =   c_ups*sig_muups;
[zz1,s1]        =   simulate(A,B_c,rho_c,e1);
e2              =   zeros(nn,T);
e2(3,1)         =   sig_muz;
e2(4,1)         =   sig_muz;
e2(5,1)         =   c_z*sig_muz;
[zz2,s2]        =   simulate(A,B_c,rho_c,e2);
modirf1_c     =   unscaleforplots(zz1,s1,alph,R,infl)';
modirf2_c     =   unscaleforplots(zz2,s2,alph,R,infl)';

pnstep  =   20;
figure
subplot(221),plot(0:pnstep-1,modirf2(1:20),'k:',0:pnstep-1,modirf2_c(1:20),'k-')
title('Output'),axis tight
subplot(222),plot(0:pnstep-1,modirf2(41:60),'k:',0:pnstep-1,modirf2_c(41:60),'k-')
title('Inflation'),axis tight
subplot(223),plot(0:pnstep-1,modirf2(61:80),'k:',0:pnstep-1,modirf2_c(61:80),'k-')
title('Fed Funds'),axis tight
subplot(224),plot(0:pnstep-1,modirf2(101:120),'k:',0:pnstep-1,modirf2_c(101:120),'k-')
title('Avg Hours'),axis tight
suptitle('Figure 13: Model dynamic responses to a neutral technology shock with (--) and without (-) monetary intervention'),
print -dps2 figure13.ps

figure
subplot(221),plot(0:pnstep-1,modirf1(1:20),'k:',0:pnstep-1,modirf1_c(1:20),'k-')
title('Output'),axis tight
subplot(222),plot(0:pnstep-1,modirf1(41:60),'k:',0:pnstep-1,modirf1_c(41:60),'k-')
title('Inflation'),axis tight
subplot(223),plot(0:pnstep-1,modirf1(61:80),'k:',0:pnstep-1,modirf1_c(61:80),'k-')
title('Fed Funds'),axis tight
subplot(224),plot(0:pnstep-1,modirf1(101:120),'k:',0:pnstep-1,modirf1_c(101:120),'k-')
title('Avg Hours'),axis tight
suptitle('Figure 14: Model dynamic responses to an embodied technology shock with (--) and without (-) monetary intervention'),
print -dps2 figure14.ps
