function [A] = findandcheckA(alphas,alpha_2,alpha_1,alpha_0)
t1=clock;
qz=0;
if qz == 1
    ne=[];    
    [A,isp]  =   solveaa(alphas,ne); 
end

if qz == 0 | isp == 1
    
    hmat            =   [alpha_2 alpha_1 alpha_0];
    [zb,hb,zf,hf]   =   numericBiDirectionalAR(hmat);
    tm              =   numericTransitionMatrix(hf);
    theq            =   numericAsymptoticConstraint(zf,zb,hf,1);
    theb            =   numericAsymptoticAR(theq);
    A               =   theb;
    [n1,n2]         =   size(A);
    if n1 ~= n2
        error('fatal (findandcheckA) anderson-moore algorithm failed')
    end
    
end
if max(max(imag(A)))>1e-10,error('fatal (findandcheckA) complex A matrix'),end
A=real(A);
Q=alpha_0*A*A+alpha_1*A+alpha_2;
qq=max(max(abs(Q)));
qz=max(abs(eig(A)));

if qq > 8.9e-7 | qz > 1
    error('fatal (findandcheckA) solveaa failed to solve for A')
end
t2=clock;
% fprintf('%g seconds used to compute A\n',etime(t2,t1))