function foncs = foncs(params_chk,vars)

c_tp1           =   vars(1);
wtilde_tp1      =   vars(2);
lambdazst_tp1   =   vars(3);
m_tp1           =   vars(4);
pi_tp1          =   vars(5);
x_tp1           =   vars(6);
s_tp1           =   vars(7);
i_tp1           =   vars(8);
h_tp1           =   vars(9);
kbar_tp2        =   vars(10);
q_tp1           =   vars(11);
ytilde_tp1      =   vars(12);
R_tp1           =   vars(13);
mutilde_tp1     =   vars(14);
rhotilde_tp1    =   vars(15);
u_tp1           =   vars(16);

c_t             =   vars(17);
wtilde_t        =   vars(18);
lambdazst_t     =   vars(19);
m_t             =   vars(20);
pi_t            =   vars(21);
x_t             =   vars(22);
s_t             =   vars(23);
i_t             =   vars(24);
h_t             =   vars(25);
kbar_tp1        =   vars(26);
q_t             =   vars(27);
ytilde_t        =   vars(28);
R_t             =   vars(29);
mutilde_t       =   vars(30);
rhotilde_t      =   vars(31);
u_t             =   vars(32);

c_tm1           =   vars(33);
wtilde_tm1      =   vars(34);
lambdazst_tm1   =   vars(35);
m_tm1           =   vars(36);
pi_tm1          =   vars(37);
x_tm1           =   vars(38);
s_tm1           =   vars(39);
i_tm1           =   vars(40);
h_tm1           =   vars(31);
kbar_t          =   vars(42);
q_tm1           =   vars(43);
ytilde_tm1      =   vars(44);
R_tm1           =   vars(45);
mutilde_tm1     =   vars(46);
rhotilde_tm1    =   vars(47);
u_tm1           =   vars(48);

x_Mtp1          =   vars(49);
eps_Mtp1        =   vars(50);
mu_ztp1         =   vars(51);
eps_muztp1      =   vars(52);
x_ztp1          =   vars(53);
mu_upstp1       =   vars(54);
eps_muupstp1    =   vars(55);
x_upstp1        =   vars(56);
x_Mt            =   vars(57);
eps_Mt          =   vars(58);
mu_zt           =   vars(59);
eps_muzt        =   vars(60);
x_zt            =   vars(61);
mu_upst         =   vars(62);
eps_muupst      =   vars(63);
x_upst          =   vars(64);

alpha       =   params_chk(1);
b           =   params_chk(2);
beta        =   params_chk(3);
delta       =   params_chk(4);
eps         =   params_chk(5);
eta         =   params_chk(6);
lambda_f    =   params_chk(7);
lambda_w    =   params_chk(8);
mu_ups      =   params_chk(9);
mu_z        =   params_chk(10);
nu          =   params_chk(11);
psi_L       =   params_chk(12);
sigma_L     =   params_chk(13);
x           =   params_chk(14);
xi_w        =   params_chk(15);
V           =   params_chk(16);

kappa       =   params_chk(17);
sigma_a     =   params_chk(18);
gamma       =   params_chk(19);
squig       =   params_chk(20);
vartheta    =   params_chk(21);

rho_M       =   params_chk(22);
theta_M     =   params_chk(23);
rho_muz     =   params_chk(24);
theta_muz   =   params_chk(25);
c_z         =   params_chk(26);
cp_z        =   params_chk(27);
rho_xz      =   params_chk(28);
rho_muups   =   params_chk(29);
theta_muups =   params_chk(30);
c_ups       =   params_chk(31);
cp_ups      =   params_chk(32);
rho_xups    =   params_chk(33);

mu_zstar    =   params_chk(34);
rhotilde    =   params_chk(35);
pi          =   params_chk(36);
R           =   params_chk(37);
eta_pr      =   params_chk(38);
sig_eta     =   params_chk(39);
s           =   params_chk(40);
R_nu        =   params_chk(41);
wtilde      =   params_chk(42);
kbar        =   params_chk(43);
h           =   params_chk(44);
c           =   params_chk(45);
q           =   params_chk(46);
m           =   params_chk(47);
ytilde      =   params_chk(48);
phi         =   params_chk(49);

AA          =   eta_pr*(1+sig_eta/2);
BB          =   V^2*eta_pr*sig_eta/2;
CC          =   eta-AA*V-BB/V;

mu_zst          =   mu_upst^(alpha/(1-alpha))*mu_zt;
mu_zstp1        =   mu_upstp1^(alpha/(1-alpha))*mu_ztp1;

tmp_t       =   i_t/i_tm1*mu_upst*mu_zst;
S_t         =   ((mu_ups*mu_zstar)^2)*kappa*((tmp_t/(mu_ups*mu_zstar))^2/2-tmp_t/(mu_ups*mu_zstar)+0.5);
Sp_t        =   ((mu_ups*mu_zstar)^2)*kappa*(tmp_t/(mu_ups*mu_zstar)^2-1/(mu_ups*mu_zstar));
tmp_tp1     =   i_tp1/i_t*mu_upstp1*mu_zstp1;
S_tp1       =   ((mu_ups*mu_zstar)^2)*kappa*((tmp_tp1/(mu_ups*mu_zstar))^2/2-tmp_tp1/(mu_ups*mu_zstar)+0.5);
Sp_tp1      =   ((mu_ups*mu_zstar)^2)*kappa*(tmp_tp1/(mu_ups*mu_zstar)^2-1/(mu_ups*mu_zstar));
aa          =   0.5*rhotilde*sigma_a;
bb          =   rhotilde*(1-sigma_a);
cc          =   rhotilde*(0.5*sigma_a-1);
au_t        =   aa*u_t^2+bb*u_t+cc;
aup_t       =   2*aa*u_t+bb;
au_tp1      =   aa*u_tp1^2+bb*u_tp1+cc;
eta_t       =   AA*c_t/q_t+BB*q_t/c_t+CC;
etapr_t     =   AA-BB*(c_t/q_t)^(-2);

foncs           =   zeros(16,1);
foncs(1)        =   beta*lambdazst_tp1/mu_zstp1*(u_tp1*rhotilde_tp1-au_tp1+mutilde_tp1*(1-delta))/(mu_upstp1*mutilde_t)-lambdazst_t;
foncs(2)        =   -lambdazst_t+lambdazst_t*mutilde_t*(1-S_t-Sp_t*(i_t/i_tm1*mu_upst*mu_zst))+ ...
    beta*lambdazst_tp1*mutilde_tp1/(mu_zstp1*mu_upstp1)*Sp_tp1*(i_tp1/i_t*mu_upstp1*mu_zstp1)^2;
foncs(3)        =   -rhotilde_t+alpha/(1-alpha)*(nu*R_t+1-nu)*wtilde_t*((ytilde_t+phi)/(u_t*kbar_t)*mu_zst*mu_upst)^(1/(1-alpha));
foncs(4)        =   kbar_tp1-(1-delta)*kbar_t/(mu_upst*mu_zst)-(1-S_t)*i_t;
foncs(6)        =   -s_t+(nu*R_t+1-nu)*wtilde_t/(1-alpha)*((ytilde_t+phi)/(u_t*kbar_t)*mu_zst*mu_upst)^(alpha/(1-alpha));
foncs(7)        =   -R_t+1+etapr_t*(c_t/q_t)^2;
foncs(8)        =   1/(c_t-b/mu_zst*c_tm1)-beta*b/(mu_zstp1*c_tp1-b*c_t)-lambdazst_t*(1+eta_t+etapr_t*c_t/q_t);
foncs(9)        =   -lambdazst_t+beta*lambdazst_tp1*R_tp1/(pi_tp1*mu_zstp1);
foncs(11)       =   -(u_t*kbar_t/(mu_zst*mu_upst))^alpha*h_t^(1-alpha)+phi+i_t+(1+eta_t)*c_t+au_t*kbar_t/(mu_zst*mu_upst);
foncs(12)       =   nu*wtilde_t*h_t+q_t-x_t*m_t;
foncs(14)       =   m_t-x_tm1*m_tm1/(pi_t*mu_zst);   
foncs(15)       =   -(ytilde_t+phi)+(u_t*kbar_t/(mu_zst*mu_upst))^alpha*h_t^(1-alpha)-au_t*kbar_t/(mu_zst*mu_upst);
foncs(16)       =   (rhotilde_t-aup_t);