function [EtechtabStd,NtechtabStd,montabStd,alltabStd,histhpStd,histbpStd,PortStatData,PortSimMat,...
        Etechtabmean,Ntechtabmean,montabmean,alltabmean,histhpmean,histbpmean] ...
         =gimpulses(vardata,impzout,nlags,nsteps,hascon,ffshk,ndraws,PortmanteauLags,a,b,lam);

%Modified by Jesper Lind, returns the standard errors for the variance
%decompositions and bootstrapped p-values for the portmanteau test for null
%of no autocorrelation upto 6 and 8 lags.

warning off
[simimp,simvd,simdata,count_var_expl,EtechtabStd,NtechtabStd,montabStd,alltabStd,histhpStd,histbpStd,PortStatData,PortSimMat, ...
   Etechtabmean,Ntechtabmean,montabmean,alltabmean,histhpmean,histbpmean] ... 
= mkimplrnewci(vardata,nlags,nsteps,hascon,[],[],ffshk,'sortlp',ndraws,PortmanteauLags,a,b,lam);

save simforfilter simdata
warning on
varnamz = char('Output','MZM Growth','Inflation','Fed Funds','Capacity Util','Avg Hours','Real Wage','Consumption','Investment','Velocity','Price of Inv.');
% [impzout,vdout,simdataout,erzout,azeroout,a0betazout,var_explode,V,D] = mkimplrnew(vardata,nlags,nsteps,hascon,[],[],ffshk,'sortlp',0);
pnstep=20; 
figure, orient landscape
for zx=1:11
    subplot(4,3,zx)
    si = squeeze(simimp(1:pnstep,zx,1,:));
    stdirf1(:,zx)    =   std(si,1,2);
    plot(0:pnstep-1,-100*impzout(1:pnstep,zx,1),'k-')
    hold on
    grpyat = [(0:pnstep-1)' 100*(-impzout(1:pnstep,zx,1)-1.96*std(si,1,2)) ; (pnstep-1:-1:0)' 100*(-impzout(pnstep:-1:1,zx,1)+1.96*std(si(pnstep:-1:1,:),1,2))];
    patch(grpyat(:,1),grpyat(:,2),[0.7 0.7 0.7],'edgecolor',[0.65 0.65 0.65]);     
    plot(0:pnstep-1,-100*impzout(1:pnstep,zx,1),'k-')
    title(varnamz(zx,:));
%     xlabel('Periods After Shock')
    axis tight
end
suptitle('Embodied Technology Shock'),print -dps2 figirfpi_lr

figure, orient landscape
for zx=1:11
    subplot(4,3,zx)
    si = squeeze(simimp(1:pnstep,zx,2,:));
    stdirf2(:,zx)    =   std(si,1,2);
    plot(0:pnstep-1,100*impzout(1:pnstep,zx,2),'k-')
    hold on
    grpyat = [(0:pnstep-1)' 100*(impzout(1:pnstep,zx,2)-1.96*std(si,1,2)) ; (pnstep-1:-1:0)' 100*(impzout(pnstep:-1:1,zx,2)+1.96*std(si(pnstep:-1:1,:),1,2))];
    patch(grpyat(:,1),grpyat(:,2),[0.7 0.7 0.7],'edgecolor',[0.65 0.65 0.65]);     
    plot(0:pnstep-1,100*impzout(1:pnstep,zx,2),'k-')
    title(varnamz(zx,:));
%     xlabel('Periods After Shock')
    axis tight
end
suptitle('Neutral Technology Shock'),print -dps2 -append figirfpi_lr

figure, orient landscape
for zx=1:11
    subplot(4,3,zx)
    si = squeeze(simimp(1:pnstep,zx,3,:));
    stdirf3(:,zx)    =   std(si,1,2);
    plot(0:pnstep-1,-100*impzout(1:pnstep,zx,3),'k-')
    hold on
    grpyat = [(0:pnstep-1)' 100*(-impzout(1:pnstep,zx,3)-1.96*std(si,1,2)) ; (pnstep-1:-1:0)' 100*(-impzout(pnstep:-1:1,zx,3)+1.96*std(si(pnstep:-1:1,:),1,2))];
    patch(grpyat(:,1),grpyat(:,2),[0.7 0.7 0.7],'edgecolor',[0.65 0.65 0.65]);     
    plot(0:pnstep-1,-100*impzout(1:pnstep,zx,3),'k-')
    title(varnamz(zx,:));
%     xlabel('Periods After Shock')
    axis tight
end
suptitle('Fed Funds Shock'),print -dps2 -append figirfpi_lr

% The minuses reflect the fact that a monetary shock in the model is an
% increase in the money growth rate (hence a decrease in the interest rate)
% and that an embodied tech shock reduces the relative price of investment
% goods
impzout(:,:,1)  =   -impzout(:,:,1);
impzout(:,:,3)  =   -impzout(:,:,3);
impzvar =   impzout(1:pnstep,:,1:3);
dimpzvar    =   diff(impzvar);
impzvar =   reshape(impzvar,1,[]);
dimpzvar    =   reshape(dimpzvar,1,[]);
tt      =   2*pnstep*size(varnamz,1);
mprestr =   [1:tt,find(abs(impzvar(tt+1:end))>1e-8)+tt];
impzvar =   impzvar(mprestr);
stdirf  =   [reshape(stdirf1,[],1);reshape(stdirf2,[],1);reshape(stdirf3,[],1)];
stdirf  =   stdirf(mprestr);
Vmat    =   sparse(diag(stdirf));
save var20pi_yunits impzvar dimpzvar Vmat
save compare20pi_yunits simimp impzout pnstep
