% fixed RDC June 16, 2004
clear all
close all
[gordonp,tmp]   =   xlsread('gordon_data.xls','Equipment');
gordonp         =   gordonp(2:end,:);
nipa            =   xlsread('c:\data\NIPA\Section7ALL_xls.xls','708 Ann');
nipap           =   nipa(44:end,22:end);
rGDP            =   xlsread('c:\data\NIPA\Section1ALL_xls.xls','102 Ann');
rGDP            =   rGDP(9,21:end);
rGDPg           =   100*(log(rGDP(2:end))-log(rGDP(1:end-1)));

run c:\matlab_code\jpl_toolbox\jplpath.m

% 1-Electrical transmission, distribution and industrial apparatus
b1          =   ols(log(gordonp(7,:))',[ones(1,37);1:37;log(nipap(16,1:37))]');

% 2-Engines and turbines
b2    =   ols(log(gordonp(4,:))',[ones(1,37);1:37;log(nipap(12,1:37))]');

% 3-Fabricated metal products
b3    =   ols(log(gordonp(3,2:37))',[ones(1,36);1:36;log(nipap(11,2:37));rGDPg(1:36)]');

% 4-General industrial equipment
b4    =   ols(log(gordonp(6,2:37))',[ones(1,36);1:36;log(nipap(15,2:37));rGDPg(2:37);rGDPg(1:36)]');

% 5-Metalworking machinery
b5    =   ols(log(gordonp(5,3:37))',[ones(1,35);log(nipap(13,3:37));log(nipap(13,2:36));log(nipap(13,1:35));rGDPg(1:35)]');

% 6-Special industry machinery
b6    =   ols(log(gordonp(20,:))',[ones(1,37);1:37;log(nipap(14,1:37))]');

% 7-Aircraft
b7    =   ols(log(gordonp(9,:))',[ones(1,37);1:37;log(nipap(20,1:37))]');

% 8-Autos
b8    =   ols(log(gordonp(8,4:37))',[ones(1,34);1:34;log(nipap(19,4:37));log(nipap(19,1:34))]');

% 9-Railroad equipment
b9    =   ols(log(gordonp(10,:))',[ones(1,37);1:37;log(nipap(22,1:37))]');

% 10-Ships and boats
b10   =   ols(log(gordonp(22,3:37))',[ones(1,35);1:35;log(nipap(21,3:37));log(nipap(21,2:36));log(nipap(21,1:35));rGDPg(3:37)]');

% 11-Trucks, buses, and truck trailers
b11   =   ols(log(gordonp(21,:))',[ones(1,37);1:37;log(nipap(18,1:37))]');

% 12-Agricultural machinery, except tractors
b12   =   ols(log(gordonp(13,3:37))',[ones(1,35);log(nipap(26,3:37));log(nipap(26,1:35))]');

% 13-Construction machinery, except tractors
b13   =   ols(log(gordonp(14,2:37))',[ones(1,36);1:36;log(nipap(27,2:37));rGDPg(1:36)]');

% 14-Electrical equipment, n.e.c.
b14   =   ols(log(gordonp(16,3:37))',[ones(1,35);log(nipap(30,3:37));log(nipap(30,1:35))]');

% 15-Furniture and fixtures
b15   =  ols(log(gordonp(11,2:37))',[ones(1,36);1:36;log(nipap(24,2:37));log(nipap(24,1:36));rGDPg(2:37)]');

% 16-Mining and oilfield machinery
b16   =   ols(log(gordonp(24,2:37))',[ones(1,36);1:36;log(nipap(28,2:37));rGDPg(1:36)]');

% 17-Other equipment
b17   =   ols(log(gordonp(23,:))',[ones(1,37);1:37;log(nipap(31,1:37))]');

% 18-Service industry machinery
b18   =   ols(log(gordonp(15,:))',[ones(1,37);1:37;log(nipap(29,1:37))]');

% 19-Tractors
b19   =   ols(log(gordonp(12,3:37))',[ones(1,35);log(nipap(25,3:37));log(nipap(25,1:35));rGDPg(2:36)]');

% 20-Communication Equipment
b20   =   ols(log(gordonp(2,2:37))',[ones(1,36);1:36;log(nipap(6,2:37));rGDPg(1:36)]');

% 21-Instruments
instphoto   =   xlsread('c:\data\NIPA\Section5ALL_xls.xls','508 Ann');
instphoto   =   instphoto(15:16,21:end);
shares      =   [instphoto(1,:)./(sum(instphoto));1-instphoto(1,:)./(sum(instphoto))];
instphoto   =   xlsread('c:\data\NIPA\Section7ALL_xls.xls','708 Ann');
instphotop  =   instphoto(50:51,21:end);
instphotoq  =   instphoto(16:17,21:end);
chw         =   chainweight(instphotoq',instphotop')';
tornip      =   [1,exp(cumsum(sum(log(instphotop(:,2:end)./instphotop(:,1:end-1)).*(shares(:,2:end)+shares(:,1:end-1))/2)))];
tornip      =   tornip/tornip(50)*100;
b21         =   ols(log(gordonp(19,3:37))',[ones(1,35);1:35;log(tornip(3:37));log(tornip(1:35))]');
% b21         =   ols(log(gordonp(19,3:37))',[ones(1,35);1:35;log(chw(3:37));log(chw(1:35))]');

% b1.beta     =   [-4.23;-0.033;1.4];
% b2.beta     =   [-3.26;-.0606;1.48];
% b3.beta     =   [-3.4;-.0313;1.23;-.01];
% b4.beta     =   [-2.22;-.0108;.76;-.01;-.01];
% b5.beta     =   [-2.27;.72;.72;-.74;-.01];
% b6.beta     =   [-2.01;-.0458;.99];
% b7.beta     =   [-3.89;-0.1497;2.37];
% b8.beta     =   [-4.7;-.0085;.84;.42];
% b9.beta     =   [-2.57;.0082;.86];
% b10.beta    =   [-3.24;-.0316;1.51;.55;-.88;.01];
% b11.beta    =   [-2.99;-.0365;1.15];
% b12.beta    =   [-3.4;1.71;-.69];
% b13.beta    =   [-2.55;-.0191;.95;-.01];
% b14.beta    =   [-2.71;1.23;-.49];
% b15.beta    =   [-3.25;-.0091;.6;.42;-.01];
% b16.beta    =   [-2.1;-.0085;.73;-.01];
% b17.beta    =   [-3.67;-.0137;1.1];
% b18.beta    =   [-3.16;-.0464;1.22];
% b19.beta    =   [-2.29;1.25;-.55;.01];
% b20.beta    =   [-5.47;-.0665;1.68;.01];
% b21.beta    =   [-1.7;-.0457;-.57;1.36];

nom         =   xlsread('c:\data\NIPA\Section5ALL_xls.xls','508 Ann');
nom         =   nom(10:39,21:end);
tmp         =   reshape(nonzeros(kron(nom(1,:),eye(29))),29,56);
shares      =   nom(2:end,:)./tmp;
snan        =   find(isnan(shares));
shares(snan)=   zeros(size(snan));
tmp         =   shares(5,:)+shares(6,:);
shares(5,:) =   tmp;
shares      =   shares([2:5,7,9:14,16:20,22:end],:);
nipa        =   xlsread('c:\data\NIPA\Section7ALL_xls.xls','708 Ann');
nipap       =   nipa(44:end,19:end);
rGDP        =   xlsread('c:\data\NIPA\Section1ALL_xls.xls','102 Ann');
rGDP        =   rGDP(9,20:end);
rGDPg       =   100*(log(rGDP(2:end))-log(rGDP(1:end-1)));
gputer      =   xlsread('gordon_data.xls','Puter');
gputer      =   gputer(2,1:12)/gputer(2,13)*nipap(4,16);

qadj        =   zeros(24,55);
qadj(11,:)  =   b1.beta'*[ones(1,55);1:55;log(nipap(16,4:end))];
qadj(7,:)   =   b2.beta'*[ones(1,55);1:55;log(nipap(12,4:end))];
qadj(6,:)   =   b3.beta'*[ones(1,55);1:55;log(nipap(11,4:end));rGDPg(2:end-1)];
qadj(10,:)  =   b4.beta'*[ones(1,55);1:55;log(nipap(15,4:end));rGDPg(3:end);rGDPg(2:end-1)];
qadj(8,:)   =   b5.beta'*[ones(1,55);log(nipap(13,4:end));log(nipap(13,3:end-1));log(nipap(13,2:end-2));rGDPg(1:end-2)];
qadj(9,:)   =   b6.beta'*[ones(1,55);1:55;log(nipap(14,4:end))];
qadj(14,:)  =   b7.beta'*[ones(1,55);1:55;log(nipap(20,4:end))];
qadj(13,:)  =   b8.beta'*[ones(1,55);1:55;log(nipap(19,4:end));log(nipap(19,1:end-3))];
qadj(16,:)  =   b9.beta'*[ones(1,55);1:55;log(nipap(22,4:end))];
qadj(15,:)  =   b10.beta'*[ones(1,55);1:55;log(nipap(21,4:end));log(nipap(21,3:end-1));log(nipap(21,2:end-2));rGDPg(3:end)];
qadj(12,:)  =   b11.beta'*[ones(1,55);1:55;log(nipap(18,4:end))];
qadj(19,:)  =   b12.beta'*[ones(1,55);log(nipap(26,4:end));log(nipap(26,2:end-2))];
qadj(20,:)  =   b13.beta'*[ones(1,55);1:55;log(nipap(27,4:end));rGDPg(2:end-1)];
qadj(23,:)  =   b14.beta'*[ones(1,55);log(nipap(30,4:end));log(nipap(30,2:end-2))];
qadj(17,:)  =   b15.beta'*[ones(1,55);1:55;log(nipap(24,4:end));log(nipap(24,1:end-3));rGDPg(3:end)];
qadj(21,:)  =   b16.beta'*[ones(1,55);1:55;log(nipap(28,4:end));rGDPg(2:end-1)];
qadj(24,:)  =   b17.beta'*[ones(1,55);1:55;log(nipap(31,4:end))];
qadj(22,:)  =   b18.beta'*[ones(1,55);1:55;log(nipap(29,4:end))];
qadj(18,:)  =   b19.beta'*[ones(1,55);log(nipap(25,4:end));log(nipap(25,1:end-3));rGDPg(2:end-1)];
qadj(3,:)   =   b20.beta'*[ones(1,55);1:55;log(nipap(6,4:end));rGDPg(2:end-1)];
qadj(4,:)   =   b21.beta'*[ones(1,55);1:55;log(tornip(1:55));[0,0,log(tornip(1:53))]];
% qadj(4,:)   =   b21.beta'*[ones(1,55);1:55;log(chw(1:55));[0,0,log(chw(1:53))]];
qadj(5,:)   =   log(nipap(9,4:end));
qadj(1,:)   =   [log(gputer),log(nipap(4,16:end))];
qadj(2,:)   =   [ones(1,12)*log(nipap(5,16)),log(nipap(5,16:end))];

qadj(11,1:37)   =   log(gordonp(7,:));
qadj(7,1:37)    =   log(gordonp(4,:));
qadj(6,1:37)    =   log(gordonp(3,:));   
qadj(10,1:37)   =   log(gordonp(6,:));   
qadj(8,1:37)    =   log(gordonp(5,:));
qadj(9,1:37)    =   log(gordonp(20,:));
qadj(14,1:37)   =   log(gordonp(9,:));
qadj(13,1:37)   =   log(gordonp(8,:));
qadj(16,1:37)   =   log(gordonp(10,:));
qadj(15,1:37)   =   log(gordonp(22,:));
qadj(12,1:37)   =   log(gordonp(21,:));
qadj(19,1:37)   =   log(gordonp(13,:));
qadj(20,1:37)   =   log(gordonp(14,:));
qadj(23,1:37)   =   log(gordonp(16,:));
qadj(17,1:37)   =   log(gordonp(11,:));
qadj(21,1:37)   =   log(gordonp(24,:));
qadj(24,1:37)   =   log(gordonp(23,:));
qadj(22,1:37)   =   log(gordonp(15,:));
qadj(18,1:37)   =   log(gordonp(12,:));
qadj(3,1:37)    =   log(gordonp(2,:));
qadj(4,1:37)    =   log(gordonp(19,:));

qadj        =   qadj-reshape(nonzeros(kron(qadj(:,1),eye(55))),24,55);
tornqvist   =   [0,cumsum(sum((qadj(:,2:end)-qadj(:,1:end-1)).*(shares(:,3:end)+shares(:,2:end-1))/2))];
tornqvist   =   tornqvist-tornqvist(50);

% Check DiFonzo article for issure with log transformation

nipaeqdef   =   xlsread('c:\data\nipa\section7ALL_xls.xls','701 Qtr');
nipaeqdef   =   log(nipaeqdef(59,4:223));

eqGCV       =   denton_uni(tornqvist',nipaeqdef',2,1,4);

load c:\research\comove\acel\jonasdata.txt
plot(1947:.25:2001.75,eqGCV.y,1947:.25:2000.75,log(jonasdata(:,3))),legend('RDC','Fisher'),title('Logs')
% figure,plot(1947:.25:2000.75,eqGCV.y(1:end-4)-log(jonasdata(:,3))),title('RDC-Fisher')
% figure,plot(1947.25:.25:2000.75,diff(log(jonasdata(:,3))'),1947.25:.25:2001.75,diff(eqGCV.y(1:end)')),legend('Fisher','RDC'),title('Log differences')
% figure,plot(1947.25:.25:2000.75,diff(log(jonasdata(:,3))')-diff(eqGCV.y(1:end-4)')),title('(1-L)*(RDC-Fisher)')

% Need to fix consumption deflator according to Fisher (2002) p. 9 by
% adding the service flow from consumer durables (?)

govtp       =   xlsread('c:\data\nipa\section7ALL_xls.xls','711 Qtr');
govtp       =   govtp(4:end,4:end);
govtcp      =   [govtp(44,1:220)',govtp(55,1:220)',govtp(68,1:220)'];
govtip      =   [govtp(51,1:220)',govtp(64,1:220)',govtp(75,1:220)'];

govtn       =   xlsread('c:\data\nipa\section3ALL_xls.xls','307 Qtr');
govtcn      =   [govtn(13,4:223)',govtn(15,4:223)',govtn(28,4:223)'];
govtin      =   [govtn(20,4:223)',govtn(24,4:223)',govtn(35,4:223)'];

govtcq      =   govtcn./govtcp;
govtiq      =   govtin./govtip;

equipp      =   exp(eqGCV.y);
equipp      =   100*equipp/mean(equipp(197:200));
nipadef     =   xlsread('c:\data\nipa\section7ALL_xls.xls','701 Qtr');

consq       =   [nipadef(27,4:223)',nipadef(32,4:223)',govtcq];
consp       =   [nipadef(28,4:223)',nipadef(33,4:223)',govtcp];
consq       =   [nipadef(27,4:223)',nipadef(32,4:223)'];
consp       =   [nipadef(28,4:223)',nipadef(33,4:223)'];
consdef     =   chainweight(consq,consp);
consdef     =   100*consdef/mean(consdef(197:200));

nomqtr      =   xlsread('c:\data\nipa\section1ALL_xls.xls','101 Qtr');
equipq      =   nomqtr(19,8:227)';
equipq      =   equipq./equipp;
equipq      =   100*equipq/mean(equipq(197:200));

gordoncd    =   xlsread('gordon_data.xls','CD');
gordoncd    =   gordoncd(2,:);
cdur        =   denton_uni(gordoncd',nipadef(23,4:151)',2,1,4);
cdint       =   cdur.y;
cdnipa      =   nipadef(23,4:223);
cdnipa      =   100*cdnipa/mean(cdnipa(141:144));
cdp         =   [cdint',cdnipa(149:end)];
cdq         =   nomqtr(12,8:227)./cdp;
cdp         =   cdp./mean(cdp(197:200))*100;
cdq         =   cdq./mean(cdq(197:200))*100;


invq        =   [nipadef(52,4:223)',equipq,nipadef(57,4:223)',cdq',govtiq];
invp        =   [nipadef(53,4:223)',equipp,nipadef(58,4:223)',cdp',govtip];
invq        =   [nipadef(52,4:223)',equipq,nipadef(57,4:223)',cdq'];
invp        =   [nipadef(53,4:223)',equipp,nipadef(58,4:223)',cdp'];
invq        =   [nipadef(52,4:223)',equipq,nipadef(62,4:223)',cdq'];
invp        =   [nipadef(53,4:223)',equipp,nipadef(63,4:223)',cdp'];
invdef      =   chainweight(invq,invp);
invdef      =   100*invdef/mean(invdef(197:200));

p_i         =   invdef./consdef;
p_e         =   equipp./consdef;

% figure,plot(1947:.25:2001.75,log(nipadef(38,4:223)./nipadef(18,4:223)),1947:.25:2001.75,log(p_i)),legend('NIPA','RDC'),title('Real investment price')

save p_i p_i p_e consdef

nominv=nomqtr(15,8:227)+nomqtr(12,8:227);

ngdpqrt =   nomqtr(10,8:227);
lrinv=log(nominv)'-log(invdef/100);
rshare=(log(nominv)'-log(p_i)-log(ngdpqrt)');
filti=bpassgen(lrinv(49:end),8,32);
filtpi=bpassgen(log(p_i(49:end)),8,32);
corrcoef(filtpi,filti)
figure
[haxes,hline1,hline2] = plotyy(1959:.25:2001.75,rshare(49:end),1959:.25:2001.75,log(p_i(49:end)));
set(haxes(1),'XLim',[1959 2001.75],'YColor',[0 0 0],'YLim',[-2.15 -1.15],'YTick',-2.15:(-1.15+2.15)/5:-1.15,'FontName','Times New Roman','FontSize',9)
set(haxes(2),'XLim',[1959 2001.75],'YColor',[0 0 0],'YLim',[-.2 .65],'YTick',-.2:(.65-(-.2))/5:.65,'FontName','Times New Roman','FontSize',9)
set(hline1,'Color',[0 0 0],'LineStyle','--','Linewidth',1.5)
set(hline2,'Color',[0 0 0],'Linewidth',1.5)
print -dps pinv.ps
figure
[haxes,hline1,hline2] = plotyy(1959:.25:2001.75,filti,1959:.25:2001.75,filtpi);
set(haxes(1),'XLim',[1959 2001.75],'YColor',[0 0 0],'XTick',[],'XTicklabel',[],'FontName','Times New Roman','FontSize',9)
set(haxes(2),'XLim',[1959 2001.75],'YColor',[0 0 0],'XTick',[],'XTicklabel',[],'FontName','Times New Roman','FontSize',9)
set(hline1,'Color',[0 0 0],'Linewidth',1.5)
set(hline2,'Color',[0 0 0],'LineStyle','--','Linewidth',1.5)
hold on,nbershading(filti,421,592,9),hold off
print -dps pinv_bc.ps
% subplot(211),plot(1947:.25:2001.75,invratio/std(invratio),'k-.',1947:.25:2001.75,p_i/std(p_i),'k'),axis tight
% subplot(212),plot(1947:.25:2001.75,filti/std(filti),'k-.',1947:.25:2001.75,filtpi/std(filtpi),'k'),axis tight,title('BC component (Corr. = -0.1894)')
% suptitle('Investment goods: quantity (- -) and price (-)')

lmanufdur   =   xlsread('empldatasec','manufdur');
lmanufdur   =   lmanufdur(:,14:end);
lmanufdur   =   reshape(lmanufdur',56*4,1);
lmanufdur   =   lmanufdur(1:end-2);
lmanufndur  =   xlsread('empldatasec','manufndur');
lmanufndur  =   lmanufndur(:,14:end);
lmanufndur  =   reshape(lmanufndur',56*4,1);
lmanufndur  =   lmanufndur(1:end-2);
lgovt       =   xlsread('empldatasec','govt');
lgovt       =   lgovt(:,14:end);
lgovt       =   reshape(lgovt',56*4,1);
lgovt       =   lgovt(1:end-2);
lserv       =   xlsread('empldatasec','serv');
lserv       =   lserv(:,14:end);
lserv       =   reshape(lserv',56*4,1);
lserv       =   lserv(1:end-2);
linv        =   lmanufdur(1:end-2);
lcons       =   lmanufndur(1:end-2)+lserv(1:end-2)+lgovt(1:end-2);

nominv  =   sum(invp.*invq,2);
nomcons =   sum(consp.*consq,2);

fGDP    =   bpassgen(log(ngdpqrt)'-log(consdef/100),8,32);
fCons   =   bpassgen(log(nomcons)-log(consdef/100),8,32);
fInv    =   bpassgen(log(nominv)-log(invdef/100),8,32);
flinv   =   bpassgen(log(linv),8,32);
flcons  =   bpassgen(log(lcons),8,32);
fltot   =   bpassgen(log(lcons+linv),8,32);
bccorr  =   corrcoef([fGDP fCons fInv flinv flcons fltot]);
bccorr  =   bccorr(1,2:end)/bccorr(1,1)
relstd  =   std(([fGDP fCons fInv flinv flcons fltot]));
relstd  =   relstd(2:end)/relstd(1)

rcons   =   log(nomcons)-log(consdef/100);
save USdata fGDP fCons fInv flinv flcons fltot rcons

figure
subplot(321),nbershading(fGDP(49:end),421,592,7),title('Output')
subplot(323),nbershading(fCons(49:end),421,592,7),title('Consumption')
subplot(325),nbershading(fInv(49:end),421,592,7),title('Investment')
subplot(322),nbershading(fltot(49:end),421,592,7),title('Aggregate Labor')
subplot(324),nbershading(flcons(49:end),421,592,7),title('Labor in the consumption good sector')
subplot(326),nbershading(flinv(49:end),421,592,7),title('Labor in the inv. good sector')
print -djpeg90 secdata