function [H,F,Q,varargout]    =   kalman_matrices(xx,par,taux,varargin)

chk=0;

%get the parameters
undo
% Steady state:

[mu_zstar,rhotilde,infl,R,eta_pr,sig_eta,s,R_nu,wtilde,kbar,h,c,q,m,ytilde,phi,i,params_ss,steady,lambda_zstar,mutilde,stst] = ...
    getsteady(alph,b,bet,delta,epsilon,eta,lambda_f,lambda_w,mu_ups,mu_z,nu,psi_L,sigma_L,x,xi_w,V,chk);

%get the parameters of the linearized canonical form:

[alpha_0,alpha_1,alpha_2,beta_0,beta_1,params_mat,tau,P] = ...
    getlinear(params_ss,kappa,sigma_a,gam,squig,vartheta,rho_M,theta_M,rho_muz,theta_muz,c_z,cp_z,rho_xz,rho_muups, ...
    theta_muups,c_ups,cp_ups,rho_xups,steady);

%find the policy rule that solves the model
%First, find (and check) the feedback part, A
alphas   = [ alpha_0, alpha_1, alpha_2];
[A] = findandcheckA(alphas,alpha_2,alpha_1,alpha_0);
if max(max(imag(A)))>1e-10,error('fatal (kalman_matrices) complex A matrix'),end
A   =   real(A);
    
%Now, find (and check, if chk=1 in findB.m) the feedforward part:

[B,rho] = findB(P,A,beta_0,beta_1,alpha_0,alpha_1,alpha_2,rho_M,theta_M,taux,chk);

alf     =   zeros(9,1);
alf(1)  =   log(mu_zstar);
alf(2)  =   log(infl);
alf(3)  =   log(ytilde)-log(h)-log(wtilde);
alf(4)  =   log(h);
alf(5)  =   log(c)-log(ytilde);
alf(6)  =   log(i)-log(ytilde);
alf(7)  =   log(R);
alf(8)  =   log(ytilde)-log(q);
alf(9)  =   -log(mu_ups);

tmp         =   eye(16);
tau_c       =   tmp(1,:);
tau_w       =   tmp(2,:);
tau_lam     =   tmp(3,:);
tau_m       =   tmp(4,:);
tau_pi      =   tmp(5,:);
tau_x       =   tmp(6,:);
tau_s       =   tmp(7,:);
tau_i       =   tmp(8,:);
tau_h       =   tmp(9,:);
tau_k       =   tmp(10,:);
tau_q       =   tmp(11,:);
tau_y       =   tmp(12,:);
tau_R       =   tmp(13,:);
tau_mu      =   tmp(14,:);
tau_rho     =   tmp(15,:);
tau_u       =   tmp(16,:);

tau_muz         =   zeros(1,10);
tau_muz(3)      =   1;
tau_muups       =   zeros(1,10);
tau_muups(6)    =   1;

tau         =   zeros(9,16);
tau(1,:)    =   tau_y-tau_h;
tau(2,:)    =   tau_pi;
tau(3,:)    =   tau_y-tau_h-tau_w;
tau(4,:)    =   tau_h;
tau(5,:)    =   tau_c-tau_y;
tau(6,:)    =   tau_i-tau_y;
tau(7,:)    =   tau_R;
tau(8,:)    =   tau_y-tau_q;

tau_bar     =   zeros(9,16);
tau_bar(1,:)=   -(tau_y-tau_h);

tau_theta       =   zeros(9,10);
tau_theta(1,:)  =   alph/(1-alph)*tau_muups+tau_muz;
tau_theta(9,:)  =   -tau_muups;

H               =   [tau,tau_bar,tau_theta];
F               =   zeros(42);
F(1:16,1:16)    =   A;
F(1:16,33:end)  =   B*rho;
F(17:32,1:16)   =   eye(16);
F(33:end,33:end)=   rho;

VV              =   zeros(10);
VV(1:2,1:2)     =   sig_M^2*ones(2);
VV(3:5,3:5)     =   sig_muz^2*ones(3);
VV(3,5)         =   c_z*VV(3,5);
VV(4,5)         =   c_z*VV(4,5);
VV(5,3)         =   c_z*VV(5,3);
VV(5,4)         =   c_z*VV(5,4);
VV(5,5)         =   c_z^2*VV(5,5);
VV(6:8,6:8)     =   sig_muups^2*ones(3);
VV(6,8)         =   c_ups*VV(6,8);
VV(7,8)         =   c_ups*VV(7,8);
VV(8,6)         =   c_ups*VV(8,6);
VV(8,7)         =   c_ups*VV(8,7);
VV(8,8)         =   c_ups^2*VV(8,8);

Q               =   zeros(42);
Q(1:16,1:16)    =   B*VV*B';
Q(1:16,33:end)  =   B*VV;
Q(33:end,1:16)  =   VV*B';
Q(33:end,33:end)=   VV;

if nargin==3
    [initV,L,G,RR]  =   dare(F',zeros(size(F)),Q);
    varargout(1)    =   {initV};
    ee=initV-F*initV*F'-Q;
    if max(max(abs(ee))) > .1e-8
        error('fatal (kalman_matrices) failed to solve Riccati Equation')
    end
elseif nargin>3
    iter=varargin{1};
    initV1  =   .01*eye(42);
    for ii = 1:20
        initVn=F*initV1*F'+Q;
        initV1=initVn;
        ee=max(max(abs(initV1-F*initV1*F'-Q)));
    end
    varargout(1)    =   {initV1};
end

varargout(2)    =   {alf};
varargout(3)    =   {tau};
varargout(4)    =   {tau_bar};
varargout(5)    =   {tau_theta};
varargout(6)    =   {VV};
varargout(7)    =   {ee};