%   Riccardo DiCecio
%   08/21/2003

%   STEP 1: Read in the DATA
clear all;
close all;

nomdata     =   xlsread('c:\data\nipa\section1ALL_xls.xls','101 Qtr');
realdata    =   xlsread('c:\data\nipa\section1ALL_xls.xls','102 Qtr');
dridata     =   csvread('DRIdata.csv',1,1);
LBOUTU      =   csvread('LBOUTU.csv',1,1);
load p_i

YRZ         =   1947:.25:2001.75;
GDP         =   nomdata(10,8:227)';
GDPQ        =   realdata(10,4:223)';
GCD         =   nomdata(12,8:227)';
GCN         =   nomdata(13,8:227)';
GCS         =   nomdata(14,8:227)';
GPI         =   nomdata(15,8:227)';
GGE         =   nomdata(29,8:227)';
LBMNU       =   dridata(1:220,1);
LBCPU       =   dridata(1:220,2);
LBOUTU      =   dridata(1:220,3);
FM2         =   dridata(1:220,4);
FYFF        =   dridata(1:220,5);
P16         =   dridata(1:220,6);
IPXMCA      =   dridata(1:220,7);
LBOUTU      =   LBOUTU(1:220);

percaphours =   LBMNU./P16;                 %per capita hours Non-farm Business
pgdp        =   GDP./GDPQ;                  %GDP deflator
ymm         =   (GDP./pgdp)./P16;           %real chain weighted level of output.
cmm         =   ((GCN+GCS+GGE)./pgdp)./P16; %consumption on nondurables and services and government. 
imm         =   ((GCD + GPI)./pgdp)./P16 ;  %consumption of durables and private investment. 
cmmratio    =   (GCN+GCS+GGE)./GDP;
immratio    =   (GCD + GPI)./GDP;
wagez       =   exp(log(LBCPU)-log(pgdp));
capu        =   IPXMCA;                     %capacity utilization

chngz = [diff(log(p_i)+log(consdef)-log(pgdp)) diff(log(ymm./percaphours)) diff(log(pgdp))];  
levlz = [log(capu)  log(percaphours) log(ymm./percaphours)-log(wagez) log(cmmratio) log(immratio) FYFF/100 log(GDP./FM2)];
vardata = [chngz levlz(2:end,:)];
vardata =   vardata(49:end,:);
load mzm
% Note: removing the spike in the MZM growth rate makes the VAR
% non-stationary
gr=diff(log(MZMsplice));
gr(96)=[gr(96) (gr(97)+gr(95))/2]*[.5 .5]';
MZMsplice1=exp(log(MZMsplice(1))+[0; cumsum(gr)]);
vardata(:,end)  =   log(GDP(50:end)./MZMsplice1(2:172));
vardata(:,end)  =   log(GDP(50:end)./MZMsplice(2:172));

%   STEP 2: Estimate VARs

nsteps  = 400;
nlags   = 4;
hascon  = 1;
nvars   = size(vardata,2);

%   identify a price of investment shock, a tech shock and a fed funds shock. (Fed Funds is the 9th variable in the VAR.)
ffshk = 9;
[impzout,vdout,simdataout,erzout,azeroout,a0betazout,var_explode,V,D] = mkimplrnew(vardata,nlags,nsteps,hascon,[],[],ffshk,'sortlp',1);
 
varnamz = char('Output','MZM Growth','Inflation','Fed Funds','Capacity Util','Avg Hours','Real Wage','Consumption','Investment','Velocity','Price of Inv.');
% [impzout,vdout,simdataout,erzout,azeroout,a0betazout,var_explode,V,D] = mkimplrnew(vardata,nlags,nsteps,hascon,[],[],ffshk,'sortlp',0);
pnstep=400; 
figure, orient landscape
for zx=1:11
    subplot(4,3,zx)
    plot(0:pnstep-1,-100*impzout(1:pnstep,zx,1),'k-')
    title(varnamz(zx,:));
%     xlabel('Periods After Shock')
    axis tight
end
suptitle('Embodied Technology Shock'),print -dps2 longrunIRFs

figure, orient landscape
for zx=1:11
    subplot(4,3,zx)
    plot(0:pnstep-1,100*impzout(1:pnstep,zx,2),'k-')
    title(varnamz(zx,:));
%     xlabel('Periods After Shock')
    axis tight
end
suptitle('Neutral Technology Shock'),print -dps2 -append longrunIRFs

figure, orient landscape
for zx=1:11
    subplot(4,3,zx)
    plot(0:pnstep-1,-100*impzout(1:pnstep,zx,3),'k-')
    title(varnamz(zx,:));
%     xlabel('Periods After Shock')
    axis tight
end
suptitle('Fed Funds Shock'),print -dps2 -append longrunIRFs

