clear all
close all
setpath

% Parameters
getparams
setup
%load up the parameters
do

taux=[1 2 4 5 8 10 14 16];%equations with limited information

load var20pi_yunits.mat
warning off MATLAB:eigs:TooManyRequestedEigsForComplexNonsym

nsteps  =   20;

init    =   imap(xx);
tic
options = optimset('Display','iter','TolFun',1e-10,'TolX',1e-8,'maxiter',0,'MaxFun',0,'LargeScale','off');
[DD,ValDD,exitflag]=fminsearch('quadform',init,options,par,taux,nsteps,impzvar,Vmat,[],1,0);

if exitflag == 0
    disp('(main_max) maximum number of function evaluations reached')
elseif exitflag > 0
    disp('(main_max) converged to a solution')
elseif exitflag < 0
    error('(main_max) did not converge to a solution')
end

if isnan(ValDD) == 1 | abs(imag(ValDD)) > .1e-0 
    error('fatal (main_max) optimized function value not a sensible number')
end

quadform(DD,par,taux,nsteps,impzvar,Vmat,[],1,0)

toc
xx      =   map(DD)
load compare20pi_yunits.mat

chk=0;
makeplots