function [modirf] = modirf(xx,par,taux,nsteps,A,computeA,chk)

% Since this file is going to use for estimation purposes, the checks have
% been switched off
% chk=1;

%get the parameters
undo
% Steady state:

[mu_zstar,rhotilde,infl,R,eta_pr,sig_eta,s,R_nu,wtilde,kbar,h,c,q,m,ytilde,phi,i,params_ss,steady,lambda_zstar,mutilde,stst] = ...
    getsteady(alph,b,bet,delta,epsilon,eta,lambda_f,lambda_w,mu_ups,mu_z,nu,psi_L,sigma_L,x,xi_w,V,chk);

%get the parameters of the linearized canonical form:

[alpha_0,alpha_1,alpha_2,beta_0,beta_1,params_mat,tau,P] = ...
    getlinear(params_ss,kappa,sigma_a,gam,squig,vartheta,rho_M,theta_M,rho_muz,theta_muz,c_z,cp_z,rho_xz,rho_muups, ...
    theta_muups,c_ups,cp_ups,rho_xups,steady);

%check that analytic and numerical derivatives coincide
if chk==1;checkderiv;end

%find the policy rule that solves the model
%First, find (and check) the feedback part, A
alphas   = [ alpha_0, alpha_1, alpha_2];
if computeA==1
    [A] = findandcheckA(alphas,alpha_2,alpha_1,alpha_0);
end
    
%Now, find (and check, if chk=1 in findB.m) the feedforward part:

[B,rho] = findB(P,A,beta_0,beta_1,alpha_0,alpha_1,alpha_2,rho_M,theta_M,taux,chk);

% Simulating an embodied technology shock
nn              =   length(rho);
T               =   nsteps+1;

e1              =   zeros(nn,T);
e1(6,1)         =   sig_muups;
e1(7,1)         =   sig_muups;
e1(8,1)         =   c_ups*sig_muups;
[zz1,s1]        =   simulate(A,B,rho,e1);

% Simulating a neutral technology shock

e2              =   zeros(nn,T);
e2(3,1)         =   sig_muz;
e2(4,1)         =   sig_muz;
e2(5,1)         =   c_z*sig_muz;
[zz2,s2]        =   simulate(A,B,rho,e2);

% Simulating a monetary policy shock

e3              =   zeros(nn,T);
e3(1,1)         =   sig_M;
e3(2,1)         =   sig_M;
[zz3,s3]        =   simulate(A,B,rho,e3);

modirf1     =   unscale(zz1,s1,alph,R,infl)';
modirf2     =   unscale(zz2,s2,alph,R,infl)';
modirf3     =   unscale(zz3,s3,alph,R,infl)';

mirf      =   [reshape(modirf1,1,prod(size(modirf1))),reshape(modirf2,1,prod(size(modirf2))),reshape(modirf3,1,prod(size(modirf3)))];

tmp         =   ([1,3,5:9,11]-1)*nsteps+1+2*size(modirf1,1);
tmp1        =   1:3*size(modirf1,1);
tmp1(tmp)   =   zeros(1,8);
modirf      =   mirf(1,nonzeros(tmp1));

