%fist, determine if there are two distinct sets of impulse response functions to plot

aa=[modirf1,modirf2,modirf3];
bb=[modirf1_f,modirf2_f,modirf3_f];

pllt=1;
if max(max(abs(aa-bb))) > .1e-10;pllt=2;end

pnstep=20;
varnamz = char('Output','MZM Growth','Inflation','Fed Funds','Capacity Util','Avg Hours','Real Wage', ...
    'Consumption','Investment','Velocity',...
    'p_{I}', 'Total money growth');

figure, orient landscape
for zx=1:11
    subplot(4,3,zx)
    si = squeeze(simimp(1:pnstep,zx,3,:));
    stdirf3(:,zx)    =   std(si,1,2);
    plot(0:pnstep-1,100*impzout(1:pnstep,zx,3),'k-')
    hold on
    grpyat = [(0:pnstep-1)' 100*(impzout(1:pnstep,zx,3)-1.96*std(si,1,2)) ; (pnstep-1:-1:0)' 100*(impzout(pnstep:-1:1,zx,3)+1.96*std(si(pnstep:-1:1,:),1,2))];
    patch(grpyat(:,1),grpyat(:,2),[0.7 0.7 0.7],'edgecolor',[0.65 0.65 0.65]);     
    plot(0:pnstep-1,100*impzout(1:pnstep,zx,3),'k-')
    plot(0:pnstep-1,modirf3((zx-1)*pnstep+1:zx*pnstep),'k.-')
    plot(0:pnstep-1,modirf3_f((zx-1)*pnstep+1:zx*pnstep),'ko-')
    title(varnamz(zx,:));
    axis tight
    hold off
end
subplot(4,3,12),plot(0:pnstep-1,modirf3(end-19:end),'k.-'),title(varnamz(12,:))
hold on,plot(0:pnstep-1,modirf3_f(end-19:end),'ko-')
if pllt == 1
    suptitle('Dynamic response to a monetary policy shock');
elseif pllt == 2
    suptitle('Benchmark model (.) and alternative model (o) - dynamic response to a monetary policy shock'),
end
figure, orient landscape
for zx=1:11
    subplot(4,3,zx)
    si = squeeze(simimp(1:pnstep,zx,2,:));
    stdirf2(:,zx)    =   std(si,1,2);
    plot(0:pnstep-1,100*impzout(1:pnstep,zx,2),'k-')
    hold on
    grpyat = [(0:pnstep-1)' 100*(impzout(1:pnstep,zx,2)-1.96*std(si,1,2)) ; (pnstep-1:-1:0)' 100*(impzout(pnstep:-1:1,zx,2)+1.96*std(si(pnstep:-1:1,:),1,2))];
    patch(grpyat(:,1),grpyat(:,2),[0.7 0.7 0.7],'edgecolor',[0.65 0.65 0.65]);     
    plot(0:pnstep-1,100*impzout(1:pnstep,zx,2),'k-')
    plot(0:pnstep-1,modirf2((zx-1)*pnstep+1:zx*pnstep),'k.-')
    plot(0:pnstep-1,modirf2_f((zx-1)*pnstep+1:zx*pnstep),'ko-')
    title(varnamz(zx,:));
    axis tight
    hold off
end
subplot(4,3,12),plot(0:pnstep-1,modirf2(end-19:end),'k.-'),title(varnamz(12,:))
hold on,plot(0:pnstep-1,modirf2_f(end-19:end),'ko-')
if pllt == 1
    suptitle('Dynamic response to a neutral technology shock');
elseif pllt == 2
    suptitle('Benchmark model (.) and alternative model (o) - dynamic response to a neutral technology shock'),
end

figure, orient landscape
for zx=1:11
    subplot(4,3,zx)
    si = squeeze(simimp(1:pnstep,zx,1,:));
    stdirf1(:,zx)    =   std(si,1,2);
    plot(0:pnstep-1,100*impzout(1:pnstep,zx,1),'k-')
    hold on
    grpyat = [(0:pnstep-1)' 100*(impzout(1:pnstep,zx,1)-1.96*std(si,1,2)) ; (pnstep-1:-1:0)' 100*(impzout(pnstep:-1:1,zx,1)+1.96*std(si(pnstep:-1:1,:),1,2))];
    patch(grpyat(:,1),grpyat(:,2),[0.7 0.7 0.7],'edgecolor',[0.65 0.65 0.65]);     
    plot(0:pnstep-1,100*impzout(1:pnstep,zx,1),'k-')
    plot(0:pnstep-1,modirf1((zx-1)*pnstep+1:zx*pnstep),'k.-')
    plot(0:pnstep-1,modirf1_f((zx-1)*pnstep+1:zx*pnstep),'ko-')
    title(varnamz(zx,:));
    axis tight
    hold off
end
subplot(4,3,12),plot(0:pnstep-1,modirf1(end-19:end),'k.-'),title(varnamz(12,:))
hold on,plot(0:pnstep-1,modirf1_f(end-19:end),'ko-')

if pllt == 1
    suptitle('Dynamic response to an embodied technology shock');
elseif pllt == 2
    suptitle('Benchmark model (.) and alternative model (o) - dynamic response to an embodied technology shock'),
end