function [Y,Y1,Y2,Y9,simdataout] = robsimulate(azeroout,a0betazout,erz,sortlev)

[n,m]=size(a0betazout);
nlag1=floor((m-1)/n);
nlag2=ceil((m-1)/n);
if nlag1 ~= nlag2
    error('fatal (robsimulate) structure of a0betazout not as expected')
end
nlags=nlag2;


fflocation=9;
[n,nvars]=size(erz);
nobs=n+nlags;
a0betaz=a0betazout(:,[2:end]);
betaz=a0betaz';
a0inv=inv(azeroout);

simdataprice =   zeros(nobs-nlags,nvars);
simdatatech  = zeros(nobs-nlags,nvars); 
simdataff  = zeros(nobs-nlags,nvars); 
simdatavel  = zeros(nobs-nlags,nvars); 

simdata  = zeros(nobs-nlags,nvars); 
fullsimdata  = zeros(nobs-nlags,nvars);  
zlag  = zeros(1,nlags*nvars);
zlagff  = zeros(1,nlags*nvars);
zlagprice  = zeros(1,nlags*nvars);
zlagtech  = zeros(1,nlags*nvars);
zlagfull  = zeros(1,nlags*nvars);
zlagvel  = zeros(1,nlags*nvars);

%calculate simulated data. 
for jj=1:(nobs-nlags)
    simdataprice(jj,:)  =(erz(jj,1)*a0inv(:,1)')+zlagprice*betaz(1:length(betaz),:);
    zlagprice        = [simdataprice(jj,:) zlagprice(1,1:(nlags-1)*nvars)];   
    simdatatech(jj,:)  =(erz(jj,2)*a0inv(:,2)')+zlagtech*betaz(1:length(betaz),:);
    zlagtech        = [simdatatech(jj,:) zlagtech(1,1:(nlags-1)*nvars)];   
    simdataff(jj,:)  =(erz(jj,fflocation)*a0inv(:,fflocation)')+zlagff*betaz(1:length(betaz),:);
    zlagff       = [simdataff(jj,:) zlagff(1,1:(nlags-1)*nvars)];   
    simdatavel(jj,:)  =(erz(jj,end)*a0inv(:,end)')+zlagvel*betaz(1:length(betaz),:);
    zlagvel      = [simdatavel(jj,:) zlagvel(1,1:(nlags-1)*nvars)];   
    simdata(jj,:)  =(erz(jj,[1 2 fflocation])*a0inv(:,[1 2 fflocation])')+zlag*betaz(1:length(betaz),:); %RDC 05/31/2004 removed fflocation to compare with jonas
    zlag        = [simdata(jj,:) zlag(1,1:(nlags-1)*nvars)];   
    fullsimdata(jj,:)  = (a0inv*erz(jj,:)')'+zlagfull*betaz(1:length(betaz),:);
    zlagfull        = [fullsimdata(jj,:) zlagfull(1,1:(nlags-1)*nvars)];
end 

Y=fullsimdata';
Y1=simdataprice';
Y2=simdatatech';
Y9=simdataff';

simdataout = cat(3,feval(sortlev,simdataprice),feval(sortlev,simdatatech),feval(sortlev,simdataff),feval(sortlev,simdata),feval(sortlev,fullsimdata));
