%main program for computing reduced form for aggregate inflation in
%New ACEL model
%
clear all
close all

mod=1;%if unity, parameters associated with equilibrium model estimated with VAR with nlag=4 (benchmark)
      %if zero, parameters associated with nlag=6.
mod=3;%
%cd c:\projects\acel\Jesper10-2004
%getparams
%cd c:\projects\acel\gamma

%Following are the parameters that were estimated 
rho_M       = 0.3982 ;
rho_xz      = 0.5682 ;
c_z         = 0.4563 ;
rho_muz     = 0.3362 ;
rho_xups    = 0.7494 ;
c_ups       = 0.1395 ;
rho_muups   = 0.3437 ;
sig_M       = 0.2836 ;
sig_muz     = 0.3344 ;
sig_muups   = 0.2972 ;
epsilon     = 1.1815 ;
kappa       = 4.7231 ;
xi_w        = 0.7302 ;
b           = 0.6742 ;
lambda_f    = 1.1117 ;
sigma_a     = 4.5112 ;
cp_z        = 0.2314 ;
cp_ups      = 0.1587 ;
gam         = 0.0255 ;
%Following are the parameters held fixed in the estimation 

psi_L       = 1.0000 ;
bet         = 0.9926 ;
mu_ups      = 1.0042 ;
mu_z        = 1.0001 ;
delta       = 0.0250 ;
alph        = 0.3600 ;
nu          = 1.0000 ;
psi_L       = 1.0000 ;
x           = 1.0170 ;
V           = 1.4300 ;
sigma_L     = 1.0000 ;
lambda_w    = 1.0500 ;
squig       = 1.0000 ;
vartheta    = 0.0000 ;
eta         = 0.0360 ;
theta_M     = 0.0000 ;
theta_muz   = 0.0000 ;
theta_muups = 0.0000 ;

mod=1;
lambdaf=lambda_f;
if mod==3;lambdaf=1.1282;end
lambdaw=lambda_w;
muups=mu_ups;
alpha=alph;
beta=bet;
del=delta;
muz=mu_z;
if mod == 0;b=.6564;end%nlag=6
sigmaL=sigma_L;
psiL=psi_L;
eps=epsilon;
siga=sigma_a;
if mod==0;siga=.8194;end
if mod==3;siga=1.7558;end

Spp=kappa;
if mod==0;Spp=5.2748;end

fixed=1;%if unity, there is a fixed cost and profits are zero in steady state, if zero, the fixed cost is zero and profits are positive in ss
[muzst,rhot,R,Rnu,wt,kb,h,q,m,pie,yt,c,phi,theta]=steady(lambdaf,lambdaw,muups,muz,beta,del,eta,b,sigmaL,psiL,V,nu,x,eps,alpha,fixed);
           
%the following numbers are 
ksip=0.3620;
skap1=0.1;
skap2=.1;
skap3=1;
[psi0,psi1,kap1,kap2,kap3,gamma,zeta,fval] = getsolveACEL(skap1,skap2,skap3,alpha,siga,theta,yt,phi,del,rhot,muzst,muups,beta,ksip,Spp);

sprintf(' kap1 = %7.4f, kap2 = %7.4f, kap3 = %0.5g, zeta = %0.5g, gamma = %0.5g, fval = %0.5g, %0.5g, %0.5g\n',kap1,kap2,kap3,zeta,gamma,fval)
sprintf(' fixed = %0.5g, siga = %0.5g\n',fixed,siga)
aa=roots([1 -kap1 -kap2]);
sprintf(' the roots = (%0.5g,%0.5g*i) (%0.5g,%0.5g*i)\n',real(aa(1)),imag(aa(1)),real(aa(2)),imag(aa(2)))

ewide=(1-beta*ksip)*(1-ksip)/ksip;
sprintf('gamma with economy-wide factor markets = %7.4f\n',ewide)

%dinfl(t) = beta*dinfl(t+1) + gamma*s(t)

skap1=kap1;
skap2=kap2;
skap3=kap3;
sskap1=kap1;
sskap2=kap2;
sskap3=kap3;
kksip=.001:.001:.9;

for ii = 1:length(kksip)
    ksip=kksip(ii);
    siga=sigma_a;%nlag=4
    if mod==3;siga=1.7558;end
    if mod==0;siga=0.8194;end%nlag=6
    [psi0,psi1,kap1,kap2,kap3,gamma,zeta,fval] = getsolveACEL(skap1,skap2,skap3,alpha,siga,theta,yt,phi,del,rhot,muzst,muups,beta,ksip,Spp);
    skap1=kap1;
    skap2=kap2;
    skap3=kap3;
    siga=10000;
    [psi0,psi1,kap1,kap2,kap3,gamma1,zeta,fval] = getsolveACEL(sskap1,sskap2,sskap3,alpha,siga,theta,yt,phi,del,rhot,muzst,muups,beta,ksip,Spp);
    sskap1=kap1;
    sskap2=kap2;
    sskap3=kap3;
    gg(ii)=gamma;
    gg1(ii)=gamma1;
    %   gg2(ii)=gamma2;
end

ewide=(1-kksip).*(1-beta*kksip)./kksip;
gammmm=gam;%nlag=4
if mod==0;gammmm=.0525;end%nlag=6
if mod==3;gammmm=.0262;end
[Y,I]=min(abs(gg-gammmm));
sprintf('value of 1/(1-ksip) that produces a gamma of %8.4f is %8.4f, ksip = %8.4f\n',gammmm,1/(1-kksip(I)),kksip(I))
plot(1./(1-kksip),gg,1./(1-kksip),gg1,'*',1./(1-kksip),ewide,'o',1./(1-kksip),gg1,1./(1-kksip),ewide,1./(1-kksip),ones(size(kksip))*gammmm)
legend('\sigma _{a}=.05','\sigma _{a}=10000','General Capital Model')
ylabel('\gamma  ')
xlabel('1/(1- \xi _{p})')
axis([1 10 0 .1])
title('Figure 16: Properties of Firm-Specific Capital Model (\Delta \pi _{t}=\beta E_{t}\Delta \pi _{t+1}+\gamma s_{t} ) ')