function simulatetimedecomp(a0betazout,azeroout,erzout,a,b,lam,Il,Iu,nlags,shp,sbp)
%if T < number of observations in data, then simulate response of the system to the fitted shocks
%otherwise, choose those shocks randomly and generate T artificial observations.

T=167-(nlags-4);
%T=4000;
N=1000;
imp=0;
cnst=0;
rnd=1;
plt=0;

for ii = 1:N
    [xx,bb] = timedecomp(a0betazout,azeroout,erzout,T,'sortlp',rnd,cnst,imp,plt,a,b,Il,Iu,nlags);
    if plt == 1
        a=num2str(ii);
        str=['random drawing',a];
        hout=suptitle(str);
        pause
    end
    XX(ii,:)=xx;
    BB(ii,:)=bb;
end

T=167-(nlags-4);
rnd=0;
[xx,bb] = timedecomp(a0betazout,azeroout,erzout,T,'sortlp',rnd,cnst,imp,plt,a,b,Il,Iu,nlags);
if plt == 1;hout=suptitle(['actual data']);end
tt=1:N;

ix1=0;
ix2=0;
ix3=0;
ix4=0;
ib1=0;
ib2=0;
ib3=0;
ib4=0;
for ii = 1:N
    if xx(1) < XX(ii,1)
        ix1=ix1+1;
    end
    if xx(2) < XX(ii,2)
        ix2=ix2+1;
    end
    if xx(3) < XX(ii,3)
        ix3=ix3+1;
    end
    if xx(4) < XX(ii,4)
        ix4=ix4+1;
    end
    if bb(1) < BB(ii,1)
        ib1=ib1+1;
    end
    if bb(2) < BB(ii,2)
        ib2=ib2+1;
    end
    if bb(3) < BB(ii,3)
        ib3=ib3+1;
    end
    if bb(4) < BB(ii,4)
        ib4=ib4+1;
    end
end

if N > 0    
    [shp,sbp,name] = spectdecomp(a,b,lam,erzout,azeroout,a0betazout);
    fid=fopen('frequency.out','w');
    fprintf(fid,'results based on a monte carlo study with %5i replications, with %5i artificial observations per replication \n',N,T);
    fprintf(fid,'p-value: frequency that simulated hp variance decomposition exceeds empirical one\n');
    fprintf(fid,'first set of results apply to HP filter\n');
    fprintf(fid,'                                      embodied shock, neutral shock, policy shock, all three shocks\n');
    mm=mean(XX);
    sm=std(XX);
    fprintf(fid,' mean (std deviation) of variance decompositions = %6.3f (%6.3f), %6.3f (%6.3f), %6.3f (%6.3f), %6.3f (%6.3f)\n',mm(1),sm(1),mm(2),sm(2),mm(3),sm(3),mm(4),sm(4));
    fprintf(fid,' estimated variance decompositions (p-value) =     %6.3f (%4.1f), %6.3f (%4.1f), %6.3f (%4.1f), %6.3f (%4.1f)\n',xx(1),100*ix1/N,xx(2),100*ix2/N,xx(3),100*ix3/N,xx(4),100*ix4/N);
    fprintf(fid,' asymptotic variance decompositions =              %6.3f,         %6.3f,         %6.3f,         %6.3f \n\n',shp(1,:));
    
    
    fprintf(fid,'results for band pass filter that isolates frequences with period %3i to frequencies with period %3i\n',a,b)
    fprintf(fid,'                                      embodied shock, neutral shock, policy shock, all three shocks\n');
    mm=mean(BB);
    sm=std(BB);
    fprintf(fid,' mean (std deviation) of variance decompositions = %6.3f (%6.3f), %6.3f (%6.3f), %6.3f (%6.3f), %6.3f (%6.3f)\n',mm(1),sm(1),mm(2),sm(2),mm(3),sm(3),mm(4),sm(4));
    fprintf(fid,' estimated variance decompositions (p-value) =     %6.3f (%4.1f), %6.3f (%4.1f), %6.3f (%4.1f), %6.3f (%4.1f)\n',bb(1),100*ib1/N,bb(2),100*ib2/N,bb(3),100*ib3/N,bb(4),100*ib4/N);
    fprintf(fid,' asymptotic variance decompositions =              %6.3f,         %6.3f,         %6.3f,         %6.3f \n\n',sbp(1,:));
    fclose(fid);
end
figure
subplot(221)
plot(tt,XX(tt,1),tt,ones(length(tt),1)*xx(1),'*',tt,ones(length(tt),1)*sbp(1,1),'o')
title('embodied shock')
subplot(222)
plot(tt,XX(tt,2),tt,ones(length(tt),1)*xx(2),'*',tt,ones(length(tt),1)*sbp(1,2),'o')
title('neutral shock')
subplot(223)
plot(tt,XX(tt,3),tt,ones(length(tt),1)*xx(3),'*',tt,ones(length(tt),1)*sbp(1,3),'o')
title('policy shock')
subplot(224)
plot(tt,XX(tt,4),tt,ones(length(tt),1)*xx(4),'*',tt,ones(length(tt),1)*sbp(1,4),'o')
title('all three shocks')
hout=suptitle('hp filter');

figure
subplot(221)
plot(tt,BB(tt,1),tt,ones(length(tt),1)*bb(1),'*',tt,ones(length(tt),1)*shp(1,1),'o')
title('embodied shock')
subplot(222)
plot(tt,BB(tt,2),tt,ones(length(tt),1)*bb(2),'*',tt,ones(length(tt),1)*shp(1,2),'o')
title('neutral shock')
subplot(223)
plot(tt,BB(tt,3),tt,ones(length(tt),1)*bb(3),'*',tt,ones(length(tt),1)*shp(1,3),'o')
title('policy shock')
subplot(224)
plot(tt,BB(tt,4),tt,ones(length(tt),1)*bb(4),'*',tt,ones(length(tt),1)*shp(1,4),'o')
title('all three shocks')
hout=suptitle(['bandpass filter (8,32)']);
disp('done')

%pl=8;
%pu=32;
%[B0,Bj] = fastspect(pl,pu);