function outimpz = sortlp(impz);
%SORTLP transforms a set of impulse responses into a different set. 
%For example can translate the response by the growth rate of productivity into the 
%response by the level of productivity
 
%titz =  char('dlp','dp','cap','avg h','prod-wage','c-y','i-y','ffund','velocity') 

impznew(:,1) = cumsum(impz(:,1));%price of investment
impznew(:,2) = cumsum(impz(:,2))+impz(:,4); %Output
impznew(:,3) =  impz(:,3); %Inflation
impznew(:,4) = impz(:,4); %average hours
impznew(:,5) = impz(:,5) + impznew(:,2); %consumption
impznew(:,6) = impz(:,6) + impznew(:,2) -impznew(:,1); %investment
impznew(:,7) = impz(:,7); %fed funds
impznew(:,8) = cumsum(impz(:,2)); %Output per capita
impznew(:,9)    =   impz(:,7)/100 - 4*impz(:,3); %real interest ratet

outimpz  = impznew(:,[4 8 1 2 5 6 9]);
titz = char('Hours','Output per capita','Price of Inv.','Output','Consumption','Investment','Real Interest Rate');

