clear all;
close all;

nomdata     =   xlsread('section1ALL_xls.xls','101 Qtr');
realdata    =   xlsread('section1ALL_xls.xls','102 Qtr');
dridata     =   csvread('DRIdata.csv',1,1);
LBOUTU      =   csvread('LBOUTU.csv',1,1);
load p_i

YRZ         =   1947:.25:2001.75;
GDP         =   nomdata(10,8:227)';
GDPQ        =   realdata(10,4:223)';
GCD         =   nomdata(12,8:227)';
GCN         =   nomdata(13,8:227)';
GCS         =   nomdata(14,8:227)';
GPI         =   nomdata(15,8:227)';
GGE         =   nomdata(29,8:227)';
LBMNU       =   dridata(1:220,1);
LBCPU       =   dridata(1:220,2);
LBOUTU      =   dridata(1:220,3);
FM2         =   dridata(1:220,4);
FYFF        =   dridata(1:220,5);
P16         =   dridata(1:220,6);
IPXMCA      =   dridata(1:220,7);
LBOUTU      =   LBOUTU(1:220);

percaphours =   LBMNU./P16;                 %per capita hours Non-farm Business
pgdp        =   GDP./GDPQ;                  %GDP deflator
ymm         =   (GDP./pgdp)./P16;           %real chain weighted level of output.
cmm         =   ((GCN+GCS+GGE)./pgdp)./P16; %consumption on nondurables and services and government. 
imm         =   ((GCD + GPI)./pgdp)./P16 ;  %consumption of durables and private investment. 
cmmratio    =   (GCN+GCS+GGE)./GDP;
immratio    =   (GCD + GPI)./GDP;
wagez       =   exp(log(LBCPU)-log(pgdp));
capu        =   IPXMCA;                     %capacity utilization

load mzm

chngz = [diff(log(p_i)+log(consdef)-log(pgdp)) diff(log(ymm./percaphours)) diff(log(pgdp))];  
%chngz = [diff(log(p_e)+log(consdef)-log(pgdp)) diff(log(ymm./percaphours)) diff(log(pgdp))];  
levlz = [log(capu)  log(percaphours) log(ymm./percaphours)-log(wagez) log(cmmratio) log(immratio) FYFF/100 log(GDP./FM2)];
vardata = [chngz levlz(2:end,:)];
vardata =   vardata(49:end,:);
% chngz = [diff(log(p_e)) diff(log(ymm./percaphours)) diff(log(pgdp))];  
% levlz = [log(capu)  log(percaphours) log(ymm./percaphours)-log(wagez) log(cmmratio) log(immratio) FYFF/100 log(GDP./FM2)];
% vardata = [chngz levlz(2:end,:)];
% vardata =   vardata(49:end,:);

load mzm
% Note: removing the spike in the MZM growth rate makes the VAR
% non-stationary
% gr=diff(log(MZMsplice));
% gr(96)=[gr(96) (gr(97)+gr(95))/2]*[.5 .5]';
% MZMsplice1=exp(log(MZMsplice(1))+[0; cumsum(gr)]);
% vardata(:,end)  =   log(GDP(50:end)./MZMsplice1(2:172));
vardata(:,end)  =   log(GDP(50:end)./MZMsplice(2:172));


% chngz = [diff(log(p_i)) diff(log(LBOUTU)-log(consdef)) diff(log(pgdp))];  
% levlz = [log(capu)  log(percaphours) log(LBOUTU)-log(consdef)-(log(wagez)+log(pgdp)-log(consdef)) log(cmmratio) log(immratio) FYFF/100 log(GDP./FM2)];
% vardata = [chngz levlz(2:end,:)];
% vardata =   vardata(49:end,:);
% chngz = [diff(log(p_e)) diff(log(LBOUTU)-log(consdef)) diff(log(pgdp))];  
% levlz = [log(percaphours) log(cmmratio) log(immratio) FYFF];
% vardata = [chngz levlz(2:end,:)];
% vardata =   vardata(32:end,:);
% chngz = [diff(log(p_i)) diff(log(LBOUTU)-log(consdef))];  
% levlz = [log(percaphours)];
% vardata = [chngz levlz(2:end,:)];
% vardata =   vardata(32:end-3,:);
% % load jonasdata.txt
% % vardata(:,1)=diff(jonasdata(31:end,2));

%   STEP 2: Estimate VARs

nsteps = 30;
nlags = 4;
hascon = 1;
nvars = size(vardata,2);

%   identify a price of investment shock, a tech shock and a fed funds shock. (Fed Funds is the 9th variable in the VAR.)
ffshk = 9;
[impzout,vdout,simdataout,erzout,azeroout,a0betazout,var_explode,V,D] = mkimplrnew(vardata,nlags,nsteps,hascon,[],[],ffshk,'sortlp',0);
varnamz = char('Output','MZM Growth','Inflation','Fed Funds','Capacity Util','Avg Hours','Real Wage','Consumption','Investment','Velocity');
hornmz  = char('1','4','8','12','30','HP','BP');


hp1    =   simdataout(:,:,1)-HPF(simdataout(:,:,1),1600);
hp5    =   simdataout(:,:,5)-HPF(simdataout(:,:,5),1600);
bp1    =   bpassgen(simdataout(:,:,1),8,32);
bp5    =   bpassgen(simdataout(:,:,5),8,32);
bp1lr   =   bpassgen(simdataout(:,:,1),32,80);
bp5lr   =   bpassgen(simdataout(:,:,5),32,80);
bp1sr   =   bpassgen(simdataout(:,:,1),2,8);
bp5sr   =   bpassgen(simdataout(:,:,5),2,8);
hpEtech  =   100*var(hp1)./var(hp5);
bpEtech  =   100*var(bp1)./var(bp5);
bpEtechLR   =   100*var(bp1lr)./var(bp5lr);
bpEtechSR   =   100*var(bp1sr)./var(bp5sr);


Etechtab    =   [100*vdout(:,1,1),100*vdout(:,4,1),100*vdout(:,8,1),100*vdout(:,12,1),100*vdout(:,30,1),hpEtech',bpEtech'];

hp2    =   simdataout(:,:,2)-HPF(simdataout(:,:,2),1600);
bp2    =   bpassgen(simdataout(:,:,2),8,32);
bp2lr  =   bpassgen(simdataout(:,:,2),32,80);
bp2sr  =   bpassgen(simdataout(:,:,2),2,8);
bpNtechLR   =   100*var(bp2lr)./var(bp5lr);
bpNtechSR   =   100*var(bp2sr)./var(bp5sr);
bpNtech  =   100*var(bp2)./var(bp5);
hpNtech  =   100*var(hp2)./var(hp5);

Ntechtab    =   [100*vdout(:,1,2),100*vdout(:,4,2),100*vdout(:,8,2),100*vdout(:,12,2),100*vdout(:,30,2),hpNtech',bpNtech'];


hp3    =   simdataout(:,:,3)-HPF(simdataout(:,:,3),1600);
bp3    =   bpassgen(simdataout(:,:,3),8,32);
bp3lr  =   bpassgen(simdataout(:,:,3),32,80);
bp3sr  =   bpassgen(simdataout(:,:,3),2,8);
bpmon  =   100*var(bp3)./var(bp5);
bpmonLR=   100*var(bp3lr)./var(bp5lr);
bpmonSR=   100*var(bp3sr)./var(bp5sr);
hpmon  =   100*var(hp3)./var(hp5);

montab    =   [100*vdout(:,1,3),100*vdout(:,4,3),100*vdout(:,8,3),100*vdout(:,12,3),100*vdout(:,30,3),hpmon',bpmon'];

hp4    =   simdataout(:,:,4)-HPF(simdataout(:,:,4),1600);
bp4    =   bpassgen(simdataout(:,:,4),8,32);
bp4lr  =   bpassgen(simdataout(:,:,4),32,80);
bp4sr  =   bpassgen(simdataout(:,:,4),2,8);
bpall  =   100*var(bp4)./var(bp5);
bpallLR=   100*var(bp4lr)./var(bp5lr);
bpallSR=   100*var(bp4sr)./var(bp5sr);
hpall  =   100*var(hp4)./var(hp5);

alltab    =   [hpall',bpall'];
montab    =   [hpmon',bpmon'];
Ntechtab  =   [hpNtech',bpNtech'];
Etechtab  =   [hpEtech',bpEtech'];

LR      =   [bpEtechLR',bpNtechLR',bpmonLR',bpallLR'];
SR      =   [bpEtechSR',bpNtechSR',bpmonSR',bpallSR'];